diff --git a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
index 6a202bb0b..0bb6b5568 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
@@ -8,7 +8,6 @@ import java.awt.image.BufferedImage;
 import java.nio.ByteBuffer;
 import java.util.ArrayList;
 import java.util.Collection;
-import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 import java.util.Objects;
@@ -16,6 +15,8 @@ import java.util.Objects;
 import com.mojang.logging.LogUtils;
 import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
+import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.popup.PopupScreen;
@@ -67,16 +68,16 @@ public class TextureManager {
 	public final Minecraft mc;
 
 	public final Int2ObjectMap<Texture> idToTextureMap = new Int2ObjectArrayMap<>();
-	public final Map<String, Texture> textureMap = new HashMap<>();
-	public final List<TextureBuffered> bufferedTextures = new ArrayList<>();
-	public final Map<String, TextureDownloaded> downloadedTextures = new HashMap<>();
-	public final Map<String, DynamicTexture> dynamicTextures = new HashMap<>();
+	public final Map<String, Texture> textureMap = new Object2ObjectOpenHashMap<>();
+	public final List<TextureBuffered> bufferedTextures = new ObjectArrayList<>();
+	public final Map<String, TextureDownloaded> downloadedTextures = new Object2ObjectOpenHashMap<>();
+	public final Map<NamespaceID, DynamicTexture> dynamicTextures = new Object2ObjectOpenHashMap<>();
 	
 	private final GameSettings gameSettings;
 	public TexturePackList texturePacks;
 	
-	private boolean clampTexture;
-	private boolean blurTexture;
+	private final boolean clampTexture;
+	private final boolean blurTexture;
 
 	public TextureManager(final Minecraft minecraft, final TexturePackList texturePacks, final GameSettings gameSettings) {
 		this.mc = minecraft;
@@ -102,9 +103,9 @@ public class TextureManager {
 			}
 		}
 
-        addDynamicTextureOverride(new DynamicTextureClock(mc), true);
-		addDynamicTextureOverride(new DynamicTextureCalendar(mc), true);
-		addDynamicTextureOverride(new DynamicTextureCompass(mc, TextureRegistry.getTexture("minecraft:item/tool_compass")), true);
+        addDynamicTextureOverride(new DynamicTextureClock(this.mc), true);
+		addDynamicTextureOverride(new DynamicTextureCalendar(this.mc), true);
+		addDynamicTextureOverride(new DynamicTextureCompass(this.mc, TextureRegistry.getTexture("minecraft:item/tool_compass")), true);
 	}
 
 	protected void addNativeDynamicTextures(int state) {
@@ -120,8 +121,8 @@ public class TextureManager {
 				addDynamicTexture(new DynamicTextureFireflyJar(TextureRegistry.getTexture("minecraft:block/lantern_firefly/" + color)));
 			}
 
-			addDynamicTexture(new DynamicTextureTrommel(mc, TextureRegistry.getTexture("minecraft:block/trommel/active_front"), true));
-			addDynamicTexture(new DynamicTextureTrommel(mc, TextureRegistry.getTexture("minecraft:block/trommel/active_back"), false));
+			addDynamicTexture(new DynamicTextureTrommel(this.mc, TextureRegistry.getTexture("minecraft:block/trommel/active_front"), true));
+			addDynamicTexture(new DynamicTextureTrommel(this.mc, TextureRegistry.getTexture("minecraft:block/trommel/active_back"), false));
 		}
 		if (state < ANIMATIONS_CUSTOM) {
 			for (final DyeColor c : DyeColor.values()) {
@@ -140,8 +141,8 @@ public class TextureManager {
 		addDynamicTextureOverride(texture, false);
 	}
 	protected void addDynamicTextureOverride(DynamicTexture texture, boolean override) {
-		if (!override && dynamicTextures.containsKey(texture.targetTexture.namespaceId)) return;
-		dynamicTextures.put(texture.targetTexture.namespaceId.namespace() + ":" + TextureRegistry.stitcherMapReverse.get(texture.targetTexture.parentAtlas) + "/" + texture.targetTexture.namespaceId.value(), texture);
+		if (!override && this.dynamicTextures.containsKey(texture.targetTexture.namespaceId)) return;
+        this.dynamicTextures.put(texture.targetTexture.namespaceId, texture);
 	}
 
 	private void loadCustomAnimations(final Collection<? super Throwable> errors) {
@@ -149,7 +150,7 @@ public class TextureManager {
 			return;
 		}
 
-		for (final AtlasStitcher stitcher : TextureRegistry.stitcherMap.values()){
+		for (final AtlasStitcher stitcher : TextureRegistry.atlases){
 			for (final IconCoordinate c : stitcher.textureMap.values()) {
 				try {
 					if (c.hasMeta("animation")) {
@@ -168,8 +169,8 @@ public class TextureManager {
 		
 		if (t == null) {
 			t = new TextureBuffered(missingTexture, false, false, false);
-			textureMap.put(name, t);
-			idToTextureMap.put(t.id(), t);
+            this.textureMap.put(name, t);
+            this.idToTextureMap.put(t.id(), t);
         }
         return t;
     }
@@ -177,7 +178,7 @@ public class TextureManager {
 	public @Nullable Texture loadTextureNoDefault(@NotNull final String name) {
 		Objects.requireNonNull(name);
 
-		Texture texture = textureMap.get(name);
+		Texture texture = this.textureMap.get(name);
 		if (texture != null) return texture;
 		if (!Minecraft.getMinecraft().texturePackList.anyHasFile(name)) return null;
 
@@ -187,8 +188,8 @@ public class TextureManager {
 				t.delete();
 				return null;
 			}
-			textureMap.put(name, t);
-			idToTextureMap.put(t.id(), t);
+            this.textureMap.put(name, t);
+            this.idToTextureMap.put(t.id(), t);
 			return t;
 		} catch (Exception e) {
             LOGGER.error("Failed to create texture for '{}'!", name, e);
@@ -198,7 +199,7 @@ public class TextureManager {
 
 	public TextureBuffered loadBufferedTexture(BufferedImage bufferedimage) { // TODO, this may need a way to reduce textures from the same BufferedImage, since this allocates a new texture to memory every time its called
 		TextureBuffered texture = new TextureBuffered(bufferedimage, false, false, false);
-		bufferedTextures.add(texture);
+        this.bufferedTextures.add(texture);
 		return texture;
 	}
 
@@ -228,7 +229,7 @@ public class TextureManager {
 		int y1 = icon.iconY;
 		glTexSubImage2D(GL_TEXTURE_2D, 0, x1, y1, icon.width, icon.height, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
 		
-		if(mc.gameSettings.mipmapLevels.value > 0 && anim.targetTexture.parentAtlas.hasMipmaps()) {
+		if(this.mc.gameSettings.mipmapLevels.value > 0 && anim.targetTexture.parentAtlas.hasMipmaps()) {
 			int levels = glGetTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAX_LEVEL);
 
 			for(int level = 1; level <= levels; level++) {
@@ -240,7 +241,7 @@ public class TextureManager {
 						int i = (y * lod) * icon.width + (x * lod);
 						int j = y * (icon.width/lod) + x;
 
-						Buffer.buffer.put(j * 4 + 0, anim.imageData[i * 4 + 0]);
+						Buffer.buffer.put(j * 4, anim.imageData[i * 4]);
 						Buffer.buffer.put(j * 4 + 1, anim.imageData[i * 4 + 1]);
 						Buffer.buffer.put(j * 4 + 2, anim.imageData[i * 4 + 2]);
 						Buffer.buffer.put(j * 4 + 3, anim.imageData[i * 4 + 3]);
@@ -262,13 +263,13 @@ public class TextureManager {
 		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
 		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
 		
-		if (blurTexture) {
+		if (this.blurTexture) {
 			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
 			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
 		}
-		if (clampTexture) {
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
+		if (this.clampTexture) {
+			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
+			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
 		} else {
 			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
 			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
@@ -291,7 +292,7 @@ public class TextureManager {
 	}
 
 	public void updateDynamicTextures(boolean isPaused) {
-        List<DynamicTexture> dynamics = new ArrayList<>(dynamicTextures.values());
+        List<DynamicTexture> dynamics = new ArrayList<>(this.dynamicTextures.values());
 		for (DynamicTexture dynamicTexture : dynamics) {
 			try {
 				if (dynamicTexture.runUpdates(isPaused)) {
@@ -299,14 +300,14 @@ public class TextureManager {
 				}
 			} catch(Exception e){
                 LOGGER.error("Exception while updating dynamic for '{}'. Removing from dynamic texture pool and skipping!", dynamicTexture.targetTexture.namespaceId, e);
-				dynamicTextures.remove(dynamicTexture.targetTexture.namespaceId); // Remove broken texture
+                this.dynamicTextures.remove(dynamicTexture.targetTexture.namespaceId); // Remove broken texture
 			}
 		}
 	}
 	
 	public BufferedImage getImage(String name) {
 		try {
-			return readImage(texturePacks.getResourceAsStream(name));
+			return readImage(this.texturePacks.getResourceAsStream(name));
 		}catch (Exception e) {
 			return Textures.missingTexture;
 		}
@@ -322,21 +323,21 @@ public class TextureManager {
         if(!errors.isEmpty()) {
         	String string = createErrorString(errors);
         	
-        	if(mc.currentScreen != null) {
-                PopupBuilder builder = new PopupBuilder(this.mc.currentScreen, mc.resolution.getScaledWidthScreenCoords() - 40);
+        	if(this.mc.currentScreen != null) {
+                PopupBuilder builder = new PopupBuilder(this.mc.currentScreen, this.mc.resolution.getScaledWidthScreenCoords() - 40);
                 builder.closeOnClickOut(0);
                 builder.closeOnEnter(0);
                 builder.closeOnEsc(0);
-                builder.withMessageBox("what", mc.resolution.getScaledHeightScreenCoords() - 120, string, Integer.MAX_VALUE);
+                builder.withMessageBox("what", this.mc.resolution.getScaledHeightScreenCoords() - 120, string, Integer.MAX_VALUE);
                 builder.withButtonGroup("ok", new String[] {"gui.options.button.done"}, new int[] {0});
             	PopupScreen popup = builder.build();
-            	
-            	mc.displayScreen(popup);
+
+                this.mc.displayScreen(popup);
         	}else {
         		String[] lines = string.split("\n");
 
                 for (String line : lines) {
-                    mc.hudIngame.addChatMessage(line);
+                    this.mc.hudIngame.addChatMessage(line);
                 }
         	}
         }
@@ -388,25 +389,25 @@ public class TextureManager {
 		// Animations may change the size of textures, so they need to be initialized before the atlas is generated
 
 		long start = System.nanoTime();
-		for (AtlasStitcher stitcher : TextureRegistry.stitcherMap.values()){
+		for (AtlasStitcher stitcher : TextureRegistry.atlases){
 			stitcher.preinit();
 		}
         LOGGER.debug("Took '{}' seconds to load atlases.", (System.nanoTime() - start) / 1_000_000_000d);
 
 		initDynamicTextures(errors);
 
-		for (AtlasStitcher stitcher : TextureRegistry.stitcherMap.values()){
+		for (AtlasStitcher stitcher : TextureRegistry.atlases){
 			stitcher.init();
 		}
 
-        for (DynamicTexture dynamicTexture : dynamicTextures.values()) {
+        for (DynamicTexture dynamicTexture : this.dynamicTextures.values()) {
             dynamicTexture.postInit();
         }
 
-		for (TextureBuffered t : bufferedTextures) {
+		for (TextureBuffered t : this.bufferedTextures) {
 			t.init();
 		}
-		for (Texture t : textureMap.values()) {
+		for (Texture t : this.textureMap.values()) {
 			t.init();
 		}
 
@@ -414,13 +415,13 @@ public class TextureManager {
 
 		Fonts.refreshFonts(this.mc.texturePackList);
 
-		mc.skinVariantList.refresh(errors);
-		mc.mainMenuBackground.refresh(errors);
+        this.mc.skinVariantList.refresh(errors);
+        this.mc.mainMenuBackground.refresh(errors);
 		
         Colorizers.reload();
         Colorizers.update(true);
-        
-        mc.worldRenderer.lightmapHelper.setup();
+
+        this.mc.worldRenderer.lightmapHelper.setup();
 	}
 
 	public void bindTexture(Texture texture) {
@@ -442,10 +443,10 @@ public class TextureManager {
 				return false;
 			}
 		}
-		TextureDownloaded texture = downloadedTextures.get(urlTexture);
+		TextureDownloaded texture = this.downloadedTextures.get(urlTexture);
 		if(texture == null) {
 			texture = new TextureDownloaded(urlTexture, imageParser);
-			downloadedTextures.put(urlTexture, texture);
+            this.downloadedTextures.put(urlTexture, texture);
 		}
 		if(!texture.isGenerated()) {
 			if(texture.image != null) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
index d810299ae..5ad45565f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
@@ -6,16 +6,15 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.client.render.tileentity.*;
-import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.*;
 import net.minecraft.core.block.piston.TileEntityMovingPistonBlock;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 
 public final class TileEntityRenderDispatcher
 {
@@ -113,7 +112,7 @@ public final class TileEntityRenderDispatcher
         this.viewLerpPosZ = camera.getZ(partialTick);
     }
 
-    public <T extends TileEntity> void renderTileEntity(final @NotNull Tessellator tessellator, final ICamera camera, final @NotNull T tileEntity, final float partialTick)
+    public <T extends TileEntity> void renderTileEntity(final @NotNull TessellatorGeneral tessellator, final ICamera camera, final @NotNull T tileEntity, final float partialTick)
     {
         final TileEntityRenderer<T> renderer = TileEntityRenderDispatcher.instance.getRenderer(tileEntity);
 
@@ -122,16 +121,8 @@ public final class TileEntityRenderDispatcher
         if (!renderer.isVisible(tileEntity, camera, partialTick)) return;
 
         assert this.world != null;
-        final float brightness;
-        if(LightmapHelper.isLightmapEnabled()) {
-            LightmapHelper.setLightmapCoord(this.world.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0));
-            brightness = 1.0f;
-        }else if(Global.accessor.isFullbrightEnabled()) {
-            brightness = 1.0f;
-        }else {
-            brightness = this.world.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
-        }
-        GL11.glColor3f(brightness, brightness, brightness);
+        GLRenderer.setLightmapCoord1i(this.world.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0));
+        GLRenderer.setColor3f(1f, 1f, 1f);
         renderer.doRender(tessellator,
             tileEntity,
             (double)tileEntity.x - renderPosX,
@@ -139,7 +130,7 @@ public final class TileEntityRenderDispatcher
             (double)tileEntity.z - renderPosZ, partialTick);
     }
 
-    public <T extends TileEntity> void renderTileEntity(final @NotNull Tessellator tessellator, final @NotNull T tileEntity, final double x, final double y, final double z, final float partialTick)
+    public <T extends TileEntity> void renderTileEntity(final @NotNull TessellatorGeneral tessellator, final @NotNull T tileEntity, final double x, final double y, final double z, final float partialTick)
     {
         final TileEntityRenderer<T> renderer = getRenderer(tileEntity);
         if(renderer != null)
